'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isString2 = require('lodash/isString');

var _isString3 = _interopRequireDefault(_isString2);

var _isArray2 = require('lodash/isArray');

var _isArray3 = _interopRequireDefault(_isArray2);

var _compact2 = require('lodash/compact');

var _compact3 = _interopRequireDefault(_compact2);

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var isClient = typeof document !== 'undefined';

var onClient = function onClient(cb) {
  if (isClient) cb(require('react-ga'));
};

var getLocationPath = function getLocationPath(location) {
  return location.pathname + location.search;
};

var logPageView = function logPageView(page, trackerNames) {
  onClient(function (ReactGA) {
    ReactGA.set({ page: page }, trackerNames);
    ReactGA.pageview(page, trackerNames);

    // Also track via Bing UET, if available
    window.uetq = window.uetq || [];
    window.uetq.push('event', 'page_view', { page_path: page });
  });
};

var TrackPageViews = (function (_React$Component) {
  _inherits(TrackPageViews, _React$Component);

  function TrackPageViews() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, TrackPageViews);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TrackPageViews.__proto__ || Object.getPrototypeOf(TrackPageViews)).call.apply(_ref, [this].concat(args))), _this), _this.getTrackerNames = function () {
      var trackingId = _this.props.trackingId;

      if ((0, _isString3.default)(trackingId)) return;

      if ((0, _isArray3.default)(trackingId)) return (0, _compact3.default)(trackingId.map(function (config) {
        return config.gaOptions && config.gaOptions.name;
      }));
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(TrackPageViews, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      onClient(function (ReactGA) {
        ReactGA.initialize(_this2.props.trackingId);
        if (_this2.props.onInit) _this2.props.onInit(ReactGA);
      });

      var page = getLocationPath(this.props.location);
      logPageView(page, this.getTrackerNames());
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var currentPage = getLocationPath(this.props.location);
      var nextPage = getLocationPath(nextProps.location);

      if (currentPage !== nextPage) {
        logPageView(nextPage, this.getTrackerNames());
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return this.props.children;
    }
  }]);

  return TrackPageViews;
})(_react2.default.Component);

TrackPageViews.propTypes = {
  children: _propTypes2.default.node.isRequired,
  trackingId: _propTypes2.default.oneOfType([_propTypes2.default.string.isRequired, _propTypes2.default.arrayOf(_propTypes2.default.shape({ trackingId: _propTypes2.default.string.isRequired })).isRequired]).isRequired,
  onInit: _propTypes2.default.func
};

exports.default = (0, _reactRouterDom.withRouter)(TrackPageViews);